--[[
	- VERSION: 1.0.1
	
	- WonderRep: A drinking game for World of Warcraft. Join the fun!

]]

------------
-- Global Vars, and strings
------------

Wbl = {
	playing = true,
	Color = {
	a = 1,
	b = 1,
	c = 0,
	HEX = "ffff00",
	id = 4,
	};
	drinks = 0,
	LockDrink = true,
	DeathDrink = true,
	Announce = true,
	SessionTime = 0,
	TimeSave = 0,
	LastDrink = 0,
	TotalDrinks = 0,
	InBg = 0,
	QuestHold = 0,
};

------------
-- Load Function
------------
function Wb_OnLoad()
	-- Register the game events neccesary for the addon
	this:RegisterEvent("PLAYER_LEVEL_UP");
	this:RegisterEvent("PLAYER_ENTERING_WORLD");
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("QUEST_LOG_UPDATE");
	this:RegisterEvent("QUEST_COMPLETE");
	this:RegisterEvent("PLAYER_DEAD");
	this:RegisterEvent("CHAT_MSG_COMBAT_HOSTILE_DEATH");
	this:RegisterEvent("CHAT_MSG_LOOT");
	this:RegisterEvent("CHAT_MSG_BG_SYSTEM_HORDE");
	this:RegisterEvent("CHAT_MSG_BG_SYSTEM_ALLIANCE");
	this:RegisterEvent("CHAT_MSG_BG_SYSTEM_NEUTRAL");
--	this:RegisterEvent("UPDATE_BATTLEFIELD_SCORE");
--	this:RegisterEvent("UPDATE_BATTLEFIELD_STATUS");
--	this:RegisterEvent("UPDATE_WORLD_STATES");
	
	-- Register our slash command
	SLASH_WONDERBOOZE1 = "/wonderbooze";
	SLASH_WONDERBOOZE2 = "/wb";
	SlashCmdList["WONDERBOOZE"] = function(msg)
		WonderBooze(msg);
	end
	
	WBDFrame:RegisterForDrag("LeftButton");
	
	-- Printing Message in Chat Frame
	if( DEFAULT_CHAT_FRAME ) then
		ChatFrame1:AddMessage("WonderBooze loaded! Verison 1.0.1", 1 , 1, 0);
	end
end

------------
-- Event Functions
------------
function Wb_OnEvent()
	if( event == "VARIABLES_LOADED" ) then
		Wbql = {};
		Wbqlo = {};
		
		if ( not Wb_version ) then
			Wb_version = "100";
		end
				
		if ( not Wb_save ) then
			Wb_save = {
				playing = true,
				colora = 1,
				colorb = 1,
				colorc = 0,
				colorid = 4;
				LockDrink = true,
				DeathDrink = true,
				Announce = true,
				Sounds = true,
				ChatFrame1:AddMessage("NEW LOAD, default values set! - WonderBooze", 1 , 1, 0);
			};
		end
		
		if (Wb_version ~= "100") then
			Wb_version = "100";
			Wb_save.Sounds = true;
		end
		
		
		Wbl.Color.a = Wb_save.colora;
		Wbl.Color.b = Wb_save.colorb;
		Wbl.Color.c = Wb_save.colorc;
		Wbl.Color.HEX = Wb_save.HEX;
		Wbl.LockDrink = Wb_save.LockDrink;
		Wbl.DeathDrink = Wb_save.DeathDrink;
		Wbl.playing = Wb_save.playing;
		Wbl.Announce = Wb_save.Announce
		
--		Wb_Status();
	end
	
	if ( event == "PLAYER_ENTERING_WORLD") then
		local x = 0;
		SetMapToCurrentZone()
		x = GetCurrentMapContinent();
		
		if ( x == -1 ) then
			for i=1, MAX_BATTLEFIELD_QUEUES do
				status, mapName, instanceID = GetBattlefieldStatus(i);	
				if ( instanceID ~= 0 ) then	
					if (mapName == "Alterac Valley") then
						Wbl.DeathDrink = true;
					else
						Wbl.DeathDrink = true;
					end
				end
			end
		else
			Wbl.DeathDrink = true;
		end
	end
	
	if ( event == "QUEST_LOG_UPDATE") then
		if (Wb_save.playing) then
			Wb_GetNewQuestInfo();
		end
	end
	
	if ( event == "PLAYER_LEVEL_UP") then
		if (Wb_save.playing) then
			Wb_LevelUp(arg1);
		end
	end
	
	if ( event == "QUEST_COMPLETE") then
		if (Wb_save.playing) then
			Wb_QuestTurnIn();
		end
	end
	
	if ( event == "PLAYER_DEAD") then
		if (Wb_save.playing) then	
			if (Wbl.DeathDrink) then
				Wb_PlayerDeath();
			end
		end
	end
	
	if ( event == "CHAT_MSG_BG_SYSTEM_HORDE") then
		if (Wb_save.playing) then
			local HordeOrAlliance = UnitFactionGroup("player");
			if (HordeOrAlliance == "Horde") then
				for i=1, MAX_BATTLEFIELD_QUEUES do
					local status, mapName, instanceID = GetBattlefieldStatus(i);
					if ( instanceID ~= 0 ) then
						if (mapName == "Arathi Basin") then
							Wb_ArathiBasin();
						elseif (mapName == "Alterac Valley") then
							Wb_AlteracValley();
						elseif (mapName == "Warsong Gulch") then
							Wb_WarsongGulch();
						end
					end
				end	
			end
		end
	end
	
	if ( event == "CHAT_MSG_BG_SYSTEM_ALLIANCE") then
		if (Wb_save.playing) then
			local HordeOrAlliance = UnitFactionGroup("player");
			if (HordeOrAlliance == "Alliance") then
				for i=1, MAX_BATTLEFIELD_QUEUES do
					local status, mapName, instanceID = GetBattlefieldStatus(i);
					if ( instanceID ~= 0 ) then
						if (mapName == "Arathi Basin") then
							Wb_ArathiBasin();
						elseif (mapName == "Alterac Valley") then
							Wb_AlteracValley();
						elseif (mapName == "Warsong Gulch") then
							Wb_WarsongGulch();
						end
					end
				end	
			end
		end
	end
	
	if ( event == "CHAT_MSG_BG_SYSTEM_NEUTRAL") then
		if (Wb_save.playing) then
			local HordeOrAlliance = UnitFactionGroup("player");
			if (HordeOrAlliance == "Horde") then
				if (string.find(arg1, "The Horde wins!")) then
					if (Wb_save.Announce) then	
						ChatFrame1:AddMessage("WonderBooze: You guys won, congrats: 3 Drinks", Wbl.Color.a, Wbl.Color.b, Wbl.Color.c);
					end
					Wb_AddADrink(3);
				elseif (string.find(arg1, "The Alliance wins!")) then
					if (Wb_save.Announce) then	
						ChatFrame1:AddMessage("WonderBooze: You guys lost, better luck next time: 1 Drink", Wbl.Color.a, Wbl.Color.b, Wbl.Color.c);
					end
					Wb_AddADrink(1);
				end
			elseif (HordeOrAlliance == "Alliance") then
				if (string.find(arg1, "The Alliance wins!")) then
					if (Wb_save.Announce) then	
						ChatFrame1:AddMessage("WonderBooze: You guys won, congrats: 3 Drinks", Wbl.Color.a, Wbl.Color.b, Wbl.Color.c);
					end
					Wb_AddADrink(3)
				elseif (string.find(arg1, "The Horde wins!")) then
					if (Wb_save.Announce) then	
						ChatFrame1:AddMessage("WonderBooze: You guys lost, better luck next time: 1 Drink", Wbl.Color.a, Wbl.Color.b, Wbl.Color.c);
					end
					Wb_AddADrink(1);
				end
			end
		end
	end
	
--	if ( event == "UPDATE_BATTLEFIELD_SCORE") then
--		ChatFrame1:AddMessage(arg1);
--		ChatFrame1:AddMessage(arg2.."score2");
--	end
	
--	if ( event == "UPDATE_BATTLEFIELD_STATUS") then
--		ChatFrame1:AddMessage(arg1.."status");
--		ChatFrame1:AddMessage(arg2.."status2");
--	end

--	if ( event == "UPDATE_WORLD_STATES") then
--		ChatFrame1:AddMessage(arg1.."states");
--		ChatFrame1:AddMessage(arg2.."states2");
--	end
	
	if ( event == "CHAT_MSG_COMBAT_HOSTILE_DEATH") then
		if (Wb_save.playing) then
			if (string.find(arg1, "You have slain (.+)!")) then
				SetMapToCurrentZone()
				x = GetCurrentMapContinent();
				if ( x == -1 ) then
					local t = true;
					local index = 1;
					local start_idx, _, deceased = string.find(arg1, "You have slain (.+)!");
					local x = GetNumBattlefieldScores();
					local HordeOrAlliance = UnitFactionGroup("player");
					local bountys = 1;
					if (x > 25) then
						bountys = 2;
					end
					if (x > 60) then
						bountys = 3;
					end
					while t do
						name, killingBlows, honorKills, deaths, honorGained, faction, rank, race, class = GetBattlefieldScore(index);
						if (name == deceased) then
							local hold = bountys;
							Wb_AddADrink(hold);
							ChatFrame1:AddMessage("WonderBooze: Drink(s) added for slaying "..deceased.." you showed him: "..hold.." drinks!", Wbl.Color.a, Wbl.Color.b, Wbl.Color.c);
							t = false;
						end
						if (index >= x) then
							t = false;
						end
						if (HordeOrAlliance == "Horde") then
							if (faction == 1) then
								bountys = bountys - 1;
								if (bountys == 0) then
									t = false;
								end
							end
						else
							if (faction == 0) then
								bountys = bountys - 1;
								if (bountys == 0) then
									t = false;
								end
							end
						end
						index = index + 1;					
					end
				end	
			elseif (string.find(arg1, "(.+) is slain by (.+)")) then
				SetMapToCurrentZone()
				x = GetCurrentMapContinent();
				if ( x == -1 ) then
					local t = true;
					local index = 1;
					local start_idx, _, deceased, killer = string.find(arg1, "(.+) is slain by (.+)!");
					local x = GetNumBattlefieldScores();
					local HordeOrAlliance = UnitFactionGroup("player");
					local bountys = 1;
					if (x > 40) then
						bountys = 2;
					end
					if (x > 60) then
						bountys = 3;
					end
					while t do
						name, killingBlows, honorKills, deaths, honorGained, faction, rank, race, class = GetBattlefieldScore(index);
						if (name == deceased) then
							local hold = bountys;
							Wb_AddADrink(hold);
							ChatFrame1:AddMessage("WonderBooze: Drink(s) added for slaying "..deceased.." you guys showed him: "..hold.." drinks!", Wbl.Color.a, Wbl.Color.b, Wbl.Color.c);
							t = false;
						end
						if (index >= x) then
							t = false;
						end
						if (HordeOrAlliance == "Horde") then
							if (faction == 1) then
								bountys = bountys - 1;
								if (bountys == 0) then
									t = false;
								end
							end
						else
							if (faction == 0) then
								bountys = bountys - 1;
								if (bountys == 0) then
									t = false;
								end
							end
						end
						index = index + 1;					
					end
				end	
			end
		end
	end
	
	if ( event == "CHAT_MSG_LOOT") then
		if (Wb_save.playing) then
			local start_idx, _, looter, itemlink, qty = string.find(arg1, "(.+) receive[s]* [lootitem]+: (.+)x([0-9]+)%.");
			if(not start_idx) then
				qty = 1;
				start_idx, _, looter, itemlink = string.find(arg1, "(.+) receive[s]* [lootitem]+: (.+).");
			end
				
			if(start_idx) then
				Wb_LootFound(looter, itemlink, qty);
				Wb_save.itemlink = itemlink;
			end
		end
	end
end

function Wb_LootFound(looter, itemlink, qty)
	local rarity = "empty";
	
	if (looter == "You") then
		if(string.find(itemlink, "cff1eff00")) then
			if (Wb_save.Announce) then
				ChatFrame1:AddMessage("WonderBooze: Drink(s) added for finding and winning "..itemlink.." item: 2 drinks!", Wbl.Color.a, Wbl.Color.b, Wbl.Color.c);
			end
			Wb_AddADrink(2);
		elseif(string.find(itemlink, "cff0070dd")) then
			if (Wb_save.Announce) then
				ChatFrame1:AddMessage("WonderBooze: Drink(s) added for finding and winning "..itemlink.." item: 4 drinks!", Wbl.Color.a, Wbl.Color.b, Wbl.Color.c);
			end
			Wb_AddADrink(4);
		elseif(string.find(itemlink, "cffa335ee")) then
			if (Wb_save.Announce) then
				ChatFrame1:AddMessage("WonderBooze: Drink(s) added for finding and winning "..itemlink.." item: 6 drinks!", Wbl.Color.a, Wbl.Color.b, Wbl.Color.c);
			end
			Wb_AddADrink(6);
		elseif(string.find(itemlink, "cffff8000")) then
			if (Wb_save.Announce) then
				ChatFrame1:AddMessage("WonderBooze: Drink(s) added for finding and winning "..itemlink.." item: 8 drinks!", Wbl.Color.a, Wbl.Color.b, Wbl.Color.c);
			end			
			Wb_AddADrink(8);
		end
	else
		if(string.find(itemlink, "cff1eff00")) then
			if (Wb_save.Announce) then
				ChatFrame1:AddMessage("WonderBooze: Drink(s) added for finding "..itemlink.." item: 1 drinks!", Wbl.Color.a, Wbl.Color.b, Wbl.Color.c);
			end	
			Wb_AddADrink(1);
		elseif(string.find(itemlink, "cff0070dd")) then
			if (Wb_save.Announce) then
				ChatFrame1:AddMessage("WonderBooze: Drink(s) added for finding "..itemlink.." item: 2 drinks!", Wbl.Color.a, Wbl.Color.b, Wbl.Color.c);
			end	
			Wb_AddADrink(2);
		elseif(string.find(itemlink, "cffa335ee")) then
			if (Wb_save.Announce) then
				ChatFrame1:AddMessage("WonderBooze: Drink(s) added for finding "..itemlink.." item: 3 drinks!", Wbl.Color.a, Wbl.Color.b, Wbl.Color.c);
			end	
			Wb_AddADrink(3);
		elseif(string.find(itemlink, "cffff8000")) then
			if (Wb_save.Announce) then
				ChatFrame1:AddMessage("WonderBooze: Drink(s) added for finding "..itemlink.." item: 4 drinks!", Wbl.Color.a, Wbl.Color.b, Wbl.Color.c);
			end	
			Wb_AddADrink(4);
		end
	end	
end

function Wb_GetNewQuestInfo()
	local numEntries, numQuests = GetNumQuestLogEntries();

	if (numQuests and numQuests > 0) then
		local i;
		for i=1, numEntries, 1 do
			local index = i;
			local quest, level, questTag, isHeader, isCollapsed, isComplete = GetQuestLogTitle(i);
			if ( not isHeader) then
				if (quest and not isHeader) then
					Wbql[quest] = {};
					if (not Wbqlo[quest] ) then
						Wbqlo[quest] = {};
					end
				end
				SelectQuestLogEntry(i);
				for j = 1, GetNumQuestLeaderBoards(), 1 do
					local text, typ, finished = GetQuestLogLeaderBoard(j);
					if (finished) then
						Wbql[quest][j] = "1";
						if (not Wbqlo[quest][j]) then
							Wbqlo[quest][j] = "1";
						end
						if (Wbqlo[quest][j] ~= "1") then
							if (Wb_save.Announce) then
								ChatFrame1:AddMessage("WonderBooze: Drink(s) added for completing a quest objective: 1 drink!", Wbl.Color.a, Wbl.Color.b, Wbl.Color.c);
							end
							Wb_AddADrink(1);
							Wbqlo[quest][j] = "1";
						end
					else
						Wbql[quest][j] = "0";
						if (not Wbqlo[quest][j]) then
							Wbqlo[quest][j] = "0";
						end
					end
				end
			end
		end
	end
end

function Wb_LevelUp(arg1)
	if (arg1 < 10) then
		if (Wb_save.Announce) then
			ChatFrame1:AddMessage("WonderBooze: Drink(s) added for leveling up: 2 drinks!", Wbl.Color.a, Wbl.Color.b, Wbl.Color.c);
		end
		Wb_AddADrink(2);
		return;
	elseif (arg1 < 25) then
		if (Wb_save.Announce) then
			ChatFrame1:AddMessage("WonderBooze: Drink(s) added for leveling up: 3 drinks!", Wbl.Color.a, Wbl.Color.b, Wbl.Color.c);
		end
		Wb_AddADrink(3);
		return;
	elseif (arg1 < 40) then
		if (Wb_save.Announce) then
			ChatFrame1:AddMessage("WonderBooze: Drink(s) added for leveling up: 4 drinks!", Wbl.Color.a, Wbl.Color.b, Wbl.Color.c);
		end
		Wb_AddADrink(4);
		return;
	elseif (arg1 < 60) then
		if (Wb_save.Announce) then
			ChatFrame1:AddMessage("WonderBooze: Drink(s) added for leveling up: 6 drinks!", Wbl.Color.a, Wbl.Color.b, Wbl.Color.c);
		end
		Wb_AddADrink(6);
		return;
	elseif (arg1 == 60) then
		if (Wb_save.Announce) then
			ChatFrame1:AddMessage("WonderBooze: Drink(s) added for leveling up: 10 drinks! Congrats on level 60!", Wbl.Color.a, Wbl.Color.b, Wbl.Color.c);
		end
		Wb_AddADrink(10);
		return;
	end
end

function Wb_PlayerDeath()
	if (Wb_save.Announce) then
		ChatFrame1:AddMessage("WonderBooze: Drink(s) added for dying: 1 drink!", Wbl.Color.a, Wbl.Color.b, Wbl.Color.c);
	end

	Wb_AddADrink(1);
end
	
function Wb_QuestTurnIn()
	SetMapToCurrentZone();
	Wbl.InBg = 0;
	local x = GetCurrentMapContinent();	
	if (x == -1) then
		for i=1, MAX_BATTLEFIELD_QUEUES do
			status, mapName, instanceID = GetBattlefieldStatus(i);	
			if ( instanceID ~= 0 ) then
				if (mapName == "Alterac Valley") then
					Wbl.InBg = 5;
				end
			end
		end
	end
	
	if (Wbl.InBg == 0) then
		if (Wb_save.Announce) then
			ChatFrame1:AddMessage("WonderBooze: Drink(s) added for turning in a quest: 1 drink!", Wbl.Color.a, Wbl.Color.b, Wbl.Color.c);
		end
		Wb_AddADrink(1);
	elseif (Wbl.InBg == 5) then
		Wbl.QuestHold = Wbl.QuestHold + 1;
		if (Wbl.QuestHold == 5) then
			if (Wb_save.Announce) then
				ChatFrame1:AddMessage("WonderBooze: Drink(s) added for turning in 5 quests: 1 drink!", Wbl.Color.a, Wbl.Color.b, Wbl.Color.c);
			end
			Wbl.QuestHold = 0;
			Wb_AddADrink(1);
		end
	end
end

function Wb_ArathiBasin()
	local HordeOrAlliance = UnitFactionGroup("player");
	local group = {};
	local playerName = UnitName("player");
	local numPartyMembers = GetNumPartyMembers();
	local index = 0;
	
	while (index < numPartyMembers) do
		index = index + 1;
		local hold = ("party"..index.."");
		group[index] = UnitName(hold);
	end
	if (string.find(arg1, "(.+) has assaulted the (.+)!")) then
		local start_idx, _, player, place = string.find(arg1, "(.+) has assaulted the (.+)!");
		if (  player == playerName or player == group[1] or player == group[2] or player == group[3] or player == group[4]) then
			if (Wb_save.Announce) then	
				ChatFrame1:AddMessage("WonderBooze: You tapped "..place..". Now just hold it: 1 Drink!", Wbl.Color.a, Wbl.Color.b, Wbl.Color.c);
			end
			Wb_AddADrink(1);
		end
	end
	if (string.find(arg1, "(.+) has defended the (.+)!")) then
		local start_idx, _, player, place = string.find(arg1, "(.+) has defended the (.+)!");
		if ( player == playerName or player == group[1] or player == group[2] or player == group[3] or player == group[4]) then
			if (Wb_save.Announce) then	
				ChatFrame1:AddMessage("WonderBooze: You defended "..place..". Way to be a team player: 1 Drink!", Wbl.Color.a, Wbl.Color.b, Wbl.Color.c);
			end
			Wb_AddADrink(1);
		end
	end
end

function Wb_AlteracValley()
end

function Wb_WarsongGulch()
	local HordeOrAlliance = UnitFactionGroup("player");
	local playerName = UnitName("player");
	local numPartyMembers = GetNumPartyMembers();
	local index = 0;
	if (HordeOrAlliance == "Horde") then
		if (string.find(arg1, "The Horde flag was returned to its base by (.+)!")) then
			if (Wb_save.Announce) then
				ChatFrame1:AddMessage("WonderBooze: You returned the flag! Now get theirs: 1 drink!", Wbl.Color.a, Wbl.Color.b, Wbl.Color.c);
			end
			Wb_AddADrink(1);
		end
		if (string.find(arg1, "(.+) has captured the Alliance flag!")) then
			if (Wb_save.Announce) then
				ChatFrame1:AddMessage("WonderBooze: You captured the flag! Good one: 1 drink!", Wbl.Color.a, Wbl.Color.b, Wbl.Color.c);
			end
			Wb_AddADrink(1);
		end
	elseif (HordeOrAlliance == "Alliance") then
		if (string.find(arg1, "The Alliance flag was returned to its base by (.+)!")) then
			if (Wb_save.Announce) then
				ChatFrame1:AddMessage("WonderBooze: You returned the flag! Now get theirs: 1 drink!", Wbl.Color.a, Wbl.Color.b, Wbl.Color.c);
			end
			Wb_AddADrink(1);
		end
		if (string.find(arg1, "(.+) has captured the Horde flag!")) then
			if (Wb_save.Announce) then
				ChatFrame1:AddMessage("WonderBooze: You captured the flag! Good one: 1 drink!", Wbl.Color.a, Wbl.Color.b, Wbl.Color.c);
			end
			Wb_AddADrink(1);
		end
	end

end
	
function Wb_OnUpdate(elapsed)
	if (Wb_save.playing) then
		Wbl.TimeSave = Wbl.TimeSave + elapsed;
		if (Wbl.TimeSave > 0.5) then
			Wbl.SessionTime = Wbl.SessionTime + Wbl.TimeSave;
			Wbl.TimeSave = 0;
			if (Wbl.SessionTime > (Wbl.LastDrink + 300)) then
				if (Wb_save.Announce) then
					local x = random(1,100);
					ChatFrame1:AddMessage("WonderBooze: You look a little bored so heres a drink: 1 drink!", Wbl.Color.a, Wbl.Color.b, Wbl.Color.c);
					if (x == 50) then
						ChatFrame1:AddMessage("WonderBooze: This drink brought to you by the Ex Red Lobster Employees of Mug'Thol!", Wbl.Color.a, Wbl.Color.b, Wbl.Color.c);
					end
				end
				Wb_AddADrink(1);
			end
		end
	end
end

function Wb_AddADrink(drinks)
	Wbl.LastDrink = Wbl.SessionTime;
	Wbl.TotalDrinks = Wbl.TotalDrinks + drinks;
	Wbl.drinks = Wbl.drinks + drinks;
	WBD_Drinks();
end

function WonderBooze(msg)
	if( msg ) then
		local command = string.lower(msg);
		if( command == "" ) then
			WonderBoozeOptions_Toggle();
		elseif ( command == "unlock" ) then
			Wb_save.LockDrink = false;
			Wbl.LockDrink = false;
			ChatFrame1:AddMessage("FALSE");
		end
		
	end
end
	