local WONDERBOOZE_COLOR_DROPDOWN_LIST = {
	{ name = "Red", color = "red" },
	{ name = "Green", color = "green" },
	{ name = "Emerald", color = "emerald" },
	{ name = "Yellow", color = "yellow" },
	{ name = "Orange", color = "orange" },
	{ name = "Blue", color = "blue" },
	{ name = "Purple", color = "purple" },
	{ name = "Cyan", color = "cyan" },	
};

function WonderBoozeOptions_GameToggle()
	if(Wb_save.playing) then
		Wb_save.playing = false;
	else
		Wb_save.playing = true;
	end
	WonderBoozeOptions_Init();
end

function WonderBoozeOptions_AnnounceToggle()
	if(Wb_save.Announce) then
		Wb_save.Announce = false;
	else
		Wb_save.Announce = true;
	end
	WonderBoozeOptions_Init();
end

function WonderBoozeOptions_SoundsToggle()
	if(Wb_save.Sounds) then
		Wb_save.Sounds = false;
	else
		Wb_save.Sounds = true;
	end
	WonderBoozeOptions_Init();
end

function WonderBoozeOptions_Toggle()
	if(WonderBoozeOptionsFrame:IsVisible()) then
		WonderBoozeOptionsFrame:Hide();
--		Wb_Status();
	else
		WonderBoozeOptions_Init();
		WonderBoozeOptionsFrame:Show();
	end
end

function WonderBoozeOptionsColorDropDown_OnLoad()
	UIDropDownMenu_Initialize(WonderBoozeOptionsColorDropDown, WonderBoozeOptionsColorDropDown_Initialize);
	UIDropDownMenu_SetSelectedID(WonderBoozeOptionsColorDropDown, Wb_save.colorid);
	UIDropDownMenu_SetWidth(80);
	UIDropDownMenu_SetButtonWidth(24);
	UIDropDownMenu_JustifyText("LEFT", WonderBoozeOptionsColorDropDown)
end

function WonderBoozeOptionsColorDropDown_Initialize()
	local info;
	for i = 1, getn(WONDERBOOZE_COLOR_DROPDOWN_LIST), 1 do
		info = { };
		info.text = WONDERBOOZE_COLOR_DROPDOWN_LIST[i].name;
		info.func = WonderBoozeOptionsColorDropDown_OnClick;
		UIDropDownMenu_AddButton(info);
	end
end


function WonderBoozeOptionsColorDropDown_OnClick()
	UIDropDownMenu_SetSelectedID(WonderBoozeOptionsColorDropDown, Wb_save.colorid);
	if ( this:GetID() == 1 ) then
		Wbl.Color.a = 1;
		Wbl.Color.b = 0;
		Wbl.Color.c = 0;
		Wbl.Color.HEX = "ff0000";
		Wbl.Color.id = 1;
		Wb_save.colorid = 1;
		Wb_save.colora = 1;
		Wb_save.colorb = 0;
		Wb_save.colorc = 0;
		Wb_save.HEX = "ff0000";	
		Wbl.frame:AddMessage("WonderBooze: Color Changed", Wbl.Color.a, Wbl.Color.b, Wbl.Color.c);
	elseif ( this:GetID() == 2 ) then
		Wbl.Color.a = 0;
		Wbl.Color.b = 1;
		Wbl.Color.c = 0;
		Wbl.Color.HEX = "00ff00";
		Wbl.Color.id = 2;
		Wb_save.colorid = 2;
		Wb_save.colora = 0;
		Wb_save.colorb = 1;
		Wb_save.colorc = 0;
		Wb_save.HEX = "00ff00";	
		Wbl.frame:AddMessage("WonderBooze: Color Changed", Wbl.Color.a, Wbl.Color.b, Wbl.Color.c);
	elseif ( this:GetID() == 3 ) then
		Wbl.Color.a = .3;
		Wbl.Color.b = .8;
		Wbl.Color.c = .5;
		Wbl.Color.HEX = "50C878";
		Wbl.Color.id = 3;
		Wb_save.colorid = 3;
		Wb_save.colora = .3;
		Wb_save.colorb = .8;
		Wb_save.colorc = .5;
		Wb_save.HEX = "50C878";
		Wbl.frame:AddMessage("WonderBooze: Color Changed", Wbl.Color.a, Wbl.Color.b, Wbl.Color.c);
	elseif ( this:GetID() == 4 ) then
		Wbl.Color.a = 1;
		Wbl.Color.b = 1;
		Wbl.Color.c = 0;
		Wbl.Color.HEX = "ffff00";
		Wbl.Color.id = 4;
		Wb_save.colorid = 4;
		Wb_save.colora = 1;
		Wb_save.colorb = 1;
		Wb_save.colorc = 0;
		Wb_save.HEX = "ffff00";
		Wbl.frame:AddMessage("WonderBooze: Color Changed", Wbl.Color.a, Wbl.Color.b, Wbl.Color.c);
	elseif ( this:GetID() == 5 ) then
		Wbl.Color.a = 1;
		Wbl.Color.b = .61;
		Wbl.Color.c = 0;
		Wbl.Color.HEX = "FFA500";
		Wbl.Color.id = 5;
		Wb_save.colorid = 5;
		Wb_save.colora = 1;
		Wb_save.colorb = .61;
		Wb_save.colorc = 0;
		Wb_save.HEX = "FFA500";
		Wbl.frame:AddMessage("WonderBooze: Color Changed", Wbl.Color.a, Wbl.Color.b, Wbl.Color.c);
	elseif ( this:GetID() == 6 ) then
		Wbl.Color.a = 0;
		Wbl.Color.b = 0;
		Wbl.Color.c = 1;
		Wbl.Color.HEX = "0000ff";
		Wbl.Color.id = 6;
		Wb_save.colorid = 6;			
		Wb_save.colora = 0;
		Wb_save.colorb = 0;
		Wb_save.colorc = 1;
		Wb_save.HEX = "0000ff";	
		Wbl.frame:AddMessage("WonderBooze: Color Changed", Wbl.Color.a, Wbl.Color.b, Wbl.Color.c);
	elseif ( this:GetID() == 7 ) then
		Wbl.Color.a = .4;
		Wbl.Color.b = 0;
		Wbl.Color.c = .6;
		Wbl.Color.HEX = "660099";
		Wbl.Color.id = 7;
		Wb_save.colorid = 7;
		Wb_save.colora = .4;
		Wb_save.colorb = 0;
		Wb_save.colorc = .6;
		Wb_save.HEX = "660099";
		Wbl.frame:AddMessage("WonderBooze: Color Changed", Wbl.Color.a, Wbl.Color.b, Wbl.Color.c);
	elseif ( this:GetID() == 8 ) then
		Wbl.Color.a = 0;
		Wbl.Color.b = 1;
		Wbl.Color.c = 1;
		Wbl.Color.HEX = "00ffff";
		Wbl.Color.id = 8;
		Wb_save.colorid = 8;
		Wb_save.colora = 0;
		Wb_save.colorb = 1;
		Wb_save.colorc = 1;
		Wb_save.HEX = "00ffff";
		Wbl.frame:AddMessage("WonderBooze: Color Changed", Wbl.Color.a, Wbl.Color.b, Wbl.Color.c);
	end
	WonderBoozeOptions_Init();
end

function WonderBoozeOptions_Thirsty()
	ChatFrame1:AddMessage("WonderBooze: Thirsty you say? Well heres a drink for you!", Wbl.Color.a, Wbl.Color.b, Wbl.Color.c);	
	Wb_AddADrink(1);
	WonderBoozeOptions_Init();
end

function WonderBoozeOptions_OnLoad()
	UIPanelWindows['WonderBoozeOptionsFrame'] = {area = 'center', pushable = 0};
end

function WonderBoozeOptions_Init()
	WonderBoozeOptions_TotalDrinksNumber:SetText(Wbl.TotalDrinks);
	UIDropDownMenu_SetSelectedID(WonderBoozeOptionsColorDropDown, Wb_save.colorid);
	WonderBoozeOptionsFrameGame:SetChecked(Wb_save.playing);
	WonderBoozeOptionsFrameAnnounce:SetChecked(Wb_save.Announce);
	WonderBoozeOptionsFrameSounds:SetChecked(Wb_save.Sounds);
end